# File: .gitlab-ci.yml
#image: docker:stable

stages:
  - test
  - build Docker image and push to Docker Hub
  - deploy to Cloud Run

services:
  - docker:stable-dind

variables:
  DOCKER_HOST: tcp://docker:2375

docker-build:
  image: docker:stable
  stage: build Docker image and push to Docker Hub
  needs: ["tests"]
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - ls -Rl
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest -f ./services/web/Dockerfile.prod ./services/web
    - docker images
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master

tests:
  image: python:3.7
  stage: test
  script:
    - pwd
    - ls -l
    - apt-get update -qy
    - pip install -r services/web/requirements.txt
    - cd services/web/prepavol
    - python -m pytest -v --cov prepavol --cov-report term --cov-report xml --junitxml=report.xml
  artifacts:
    reports:
      junit: services/web/prepavol/report.xml
      coverage_report:
        coverage_format: cobertura
        path: services/web/prepavol/coverage.xml

gcloud:
  stage: deploy to Cloud Run
  needs: ["tests", "docker-build"]
  image: google/cloud-sdk
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - echo $GCP_SERVICE_KEY > gcloud-service-key.json # Google Cloud service accounts
    - gcloud auth activate-service-account --key-file gcloud-service-key.json
    - gcloud config set project $GCP_PROJECT_ID
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - gcloud builds submit . --config=cloudbuild.yaml
  only:
    - master
